package com.ishchuk.antlr.json.model;

import java.util.ArrayList;
import java.util.List;

public class JsonArray extends JsonElement {

    private List<JsonElement> array;

    public List<JsonElement> getArray() {
        return array;
    }

    public JsonArray() {
        this.array = new ArrayList<>();
    }

    public String toString() {
        StringBuilder builder = new StringBuilder();
        builder.append("[");
        this.array.forEach(obj ->{
            builder.append(obj.toString()).append(",");
        });
        int lastIndex = builder.lastIndexOf(",");
        if (lastIndex > 0) {
            builder.deleteCharAt(lastIndex);
        }
        builder.append("]");
        return builder.toString();
    }

    @Override
    public String toYml(String delay) {
        StringBuilder builder = new StringBuilder();
        this.array.forEach(obj ->{
            builder.append(delay).append("- ");
            if (obj instanceof JsonPrimitive) {
                builder.append(obj.toString()).append("\n");
            } else {
                builder.append(obj.toYml(""));
            }
        });

        return builder.toString();
    }

    public static void main() {
        System.out.println("Hello! With this application you can parse a JSON file and convert it to YAML");
        System.out.println("-----------------------------------------------------------------------------");
        System.out.println("Put ");
    }
}
